import processing.sound.*;
import org.openkinect.freenect.*;
import org.openkinect.processing.*;



ArrayList myParticles;
ArrayList mySounds;

KinectTracker tracker;
Kinect kinect;

SinOsc dancer;

float freq=400;
float pos;

float volume;

int dancerX, dancerY;
float easing = .1;

void setup() {
  
  size(640, 520);
  background(0);
  noStroke();
  
  myParticles = new ArrayList();
  
  dancer = new SinOsc(this);
  dancer.play();
  
  kinect = new Kinect(this);
  tracker = new KinectTracker();
  
}


void draw(){
  
  fill(0,5);
  rect(0,0,width,height);
  
  dancer.amp(volume);
  
  for (int i=myParticles.size()-1; i>= 0; i--) {
    
    Particle temp = (Particle) myParticles.get(i);
    temp.draw();
    temp.update();
    //temp.x += mouseX;
    
  }
  
  getKinectPosition();
  
}


void keyPressed() {
  
  myParticles.add(new Particle());
  volume+=.1;
  
}

void mouseMoved() {
 
  /*for (int i=myParticles.size()-1; i>= 0; i--) {
    
    Particle temp = (Particle) myParticles.get(i);
    
    temp.targetX = random(mouseX-volume*100,mouseX+volume*100);
    temp.targetY = random(mouseY-volume*100,mouseY+volume*100);
    
  }*/
  
  
}


void getKinectPosition() {
  
  // Run the tracking analysis
  tracker.track();
  // Show the image
  tracker.display();
  
  PVector v2 = tracker.getLerpedPos();
  //fill(255,0,0);
  //ellipse(v2.x, v2.y, 20, 20);
  
  
  for (int i=myParticles.size()-1; i>= 0; i--) {
    
    Particle temp = (Particle) myParticles.get(i);
    
    temp.targetX = random(v2.x-volume*100,v2.x+volume*100);
    temp.targetY = random(v2.y-volume*100,v2.y+volume*100);
    
  }
  
}